package com.cultural.heritage.service.common;

import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;
import java.util.function.Function;

public interface CommonService {


    /**
     * 取出一个集合的某个id列表, 去另外一个集合中筛选出属于这个id列表的集合
     */
    <T, R> List<R> getItemsByIds(List<T> records, IService<R> genericService, Function<T, Long> getId);



    /**
     * 根据 ID 列表获取对应的实体列表
     */
    <T> List<T> getListByIds(List<Long> ids, IService<T> genericService);



    /**
     * 从第一个集合中提取某个属性值，并用这些值作为查询条件去查询第二个集合的数据。
     * @param sourceList 原始集合（源数据）
     * @param service 要执行查询的 Service
     * @param sourceField 在原始集合中提取的字段名
     * @param targetField 在目标集合中的查询字段名
     * @param <T> 目标查询实体类型
     * @return 查询结果集合
     */
    <T> List<T> findListByField(List<?> sourceList, IService<T> service, String sourceField, String targetField);
}
